import time


class PerfTimer:
    def __init__(self, name='timer', size=5, wrap=True, time=time.time):
        self._name = name
        self._start = None
        self._times = []
        self._size = size
        self._time = time
        self._wrap = wrap
        self._count = 0


    def start(self):
        self._start = self._time()


    def stop(self):
        t = self._time()
        self._count += 1
        if self._start is not None:
            if self._wrap:
                self._times.append(t - self._start)
                excess = len(self._times) - self._size
                if excess > 0:
                    del self._times[:excess]
            elif len(self._times) < self._size:
                self._times.append(t - self._start)


    def reset(self):
        del self._times[:]


    def __repr__(self):
        return '<PerfTimer %r>' % self._name


    def __str__(self):
        return '{} #{}: [{}]'.format(self._name, self._count,
            ', '.join('{:.1f}ms'.format(t*1000) for t in self._times))


# EOF
